Subroutine MULCNT (XVALT, IMULT)
!   MULCNT = Give for each array value its multiplicity
!            (number of times that it appears in the array)
! __________________________________________________________
!  Michel Olagnon - Mar. 2000
! __________________________________________________________
   Real, Dimension (:), Intent (In) :: XVALT
   Integer, Dimension (Size(XVALT)), Intent (Out) :: IMULT
! __________________________________________________________
      Interface
         Subroutine UNIINV (XVALT, IGOEST)
!   UNIINV = Merge-sort inverse ranking of an array
!            Gives for each index the index of that value in an ordered set
!            where duplicate entries would be removed
            Real, Dimension (:), Intent (In) :: XVALT
            Integer, Dimension (:), Intent (Out) :: IGOEST
         End Subroutine UNIINV
      End Interface
      Integer, Dimension (Size(XVALT)) :: IWRKT
      Integer, Dimension (Size(XVALT)) :: ICNTT
      Integer :: ICRS
! __________________________________________________________
      Call UNIINV (XVALT, IWRKT)
      ICNTT = 0
      Do ICRS = 1, Size(XVALT)
            ICNTT(IWRKT(ICRS)) = ICNTT(IWRKT(ICRS)) + 1
      End Do
      Do ICRS = 1, Size(XVALT)
            IMULT(ICRS) = ICNTT(IWRKT(ICRS))
      End Do
End Subroutine MULCNT
